Index: EcnlProtoTool/trunk/asp3_dcre/cfg/cfg.rb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/cfg/cfg.rb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/cfg/cfg.rb	(revision 429)
@@ -1,3 +1,3 @@
-#!/usr/bin/env ruby
+#!/usr/bin/env ruby -Eutf-8 -w
 # -*- coding: utf-8 -*-
 #
@@ -5,5 +5,5 @@
 #
 #  Copyright (C) 2015 by FUJI SOFT INCORPORATED, JAPAN
-#  Copyright (C) 2015,2016 by Embedded and Real-Time Systems Laboratory
+#  Copyright (C) 2015-2019 by Embedded and Real-Time Systems Laboratory
 #              Graduate School of Information Science, Nagoya Univ., JAPAN
 #
@@ -37,5 +37,5 @@
 #  の責任を負わない．
 #
-#  $Id$
+#  $Id: cfg.rb 175 2019-06-19 01:51:58Z ertl-hiro $
 #
 
@@ -56,16 +56,18 @@
 #
 # 共通
-VERSION = "1.2.2"
+VERSION = "1.5.0"
 
 # cfg1_out関係
-CFG1_PREFIX        = "TOPPERS_cfg_"
-CFG1_MAGIC_NUM     = "TOPPERS_magic_number"
-CFG1_SIZEOF_SIGNED = "TOPPERS_sizeof_signed_t"
-CFG1_OUT_C         = "cfg1_out.c"
-CFG1_OUT_DB        = "cfg1_out.db"
-CFG1_OUT_SREC      = "cfg1_out.srec"
-CFG1_OUT_SYMS      = "cfg1_out.syms"
-CFG1_OUT_TIMESTAMP = "cfg1_out.timestamp"
-CFG1_OUT_TARGET_H  = "target_cfg1_out.h"
+CFG1_PREFIX         = "TOPPERS_cfg_"
+CFG1_MAGIC_NUM      = "TOPPERS_magic_number"
+CFG1_SIZEOF_SIGNED  = "TOPPERS_sizeof_signed_t"
+CFG1_SIZEOF_INTPTR  = "TOPPERS_sizeof_intptr_t"
+CFG1_SIZEOF_CHARPTR = "TOPPERS_sizeof_char_ptr_t"
+CFG1_OUT_C          = "cfg1_out.c"
+CFG1_OUT_DB         = "cfg1_out.db"
+CFG1_OUT_SREC       = "cfg1_out.srec"
+CFG1_OUT_SYMS       = "cfg1_out.syms"
+CFG1_OUT_TIMESTAMP  = "cfg1_out.timestamp"
+CFG1_OUT_TARGET_H   = "target_cfg1_out.h"
 
 # cfg2_out関係
@@ -105,5 +107,5 @@
 $noParseError = 0
 def parse_error(cfgFile, message)
-  error(message, "#{cfgFile.getFileName()}:#{cfgFile.getLineNo}:")
+  error(message, "#{cfgFile.getFileName}:#{cfgFile.getLineNo}:")
   if ($noParseError += 1) >= 10
     abort("too many errors emitted, stopping now")
@@ -113,5 +115,5 @@
 # システムコンフィギュレーションファイルの構文解析時の警告
 def parse_warning(cfgFile, message)
-  warning(message, "#{cfgFile.getFileName()}:#{cfgFile.getLineNo}:")
+  warning(message, "#{cfgFile.getFileName}:#{cfgFile.getLineNo}:")
 end
 
@@ -155,9 +157,4 @@
 def error_ercd(errorCode, params, message)
   error_api(params, "#{errorCode}: #{message}")
-end
-
-# 静的API処理時の警告（エラーコード付き）
-def warning_ercd(errorCode, params, message)
-  warning_api(params, "#{errorCode}: #{message}")
 end
 
@@ -316,5 +313,5 @@
   # ハッシュのキーとして使う時の比較も数値情報で行う
   def eql?(other)
-    @val == other.val
+    @val == other
   end
 
@@ -390,4 +387,8 @@
     if symbolData.has_key?(:VALUE)
       eval("$#{symbolName} = #{symbolData[:VALUE]}")
+      if symbolData.has_key?(:NUMSTRVAR)
+        eval("$#{symbolData[:NUMSTRVAR]} = " \
+					"NumStr.new(symbolData[:VALUE], symbolData[:EXPR])")
+      end
     end
   end
@@ -431,4 +432,15 @@
 
 #
+#  インクルードディレクティブ（#include）の生成
+#
+def GenerateIncludes(genFile)
+  $cfgFileInfo.each do |cfgInfo|
+    if cfgInfo.has_key?(:DIRECTIVE)
+      genFile.add(cfgInfo[:DIRECTIVE])
+    end
+  end
+end
+
+#
 #  パス3の処理
 #
@@ -439,14 +451,8 @@
   db = PStore.new(CFG2_OUT_DB)
   db.transaction(true) do
-    $apiDefinition = db[:apiDefinition]
-    $symbolValueTable = db[:symbolValueTable]
-    $cfgFileInfo = db[:cfgFileInfo]
-    $includeFiles = db[:includeFiles]
-    $cfgData = db[:cfgData]
-    $asmLabel = db[:asmLabel]
-    $endianLittle = db[:endianLittle]
-    $cfg2Data = db[:cfg2Data]
-  end
-  $cfg3Data = {}
+    db.roots.each do |var|
+      eval("$#{var} = db[:#{var}]")
+    end
+  end
 
   #
@@ -465,15 +471,10 @@
   #  パス4に引き渡す情報をファイルに生成
   #
-  if $omitOutputDb.nil?
+  if !$omitOutputDb
     db = PStore.new(CFG3_OUT_DB)
     db.transaction do
-      db[:apiDefinition] = $apiDefinition
-      db[:symbolValueTable] = $symbolValueTable
-      db[:cfgFileInfo] = $cfgFileInfo
-      db[:includeFiles] = $includeFiles
-      db[:cfgData] = $cfgData
-      db[:asmLabel] = $asmLabel
-      db[:endianLittle] = $endianLittle
-      db[:cfg3Data] = $cfg3Data
+      $globalVars.each do |var|
+        eval("db[:#{var}] = $#{var}")
+      end
     end
   end
@@ -489,12 +490,7 @@
   db = PStore.new(CFG3_OUT_DB)
   db.transaction(true) do
-    $apiDefinition = db[:apiDefinition]
-    $symbolValueTable = db[:symbolValueTable]
-    $cfgFileInfo = db[:cfgFileInfo]
-    $includeFiles = db[:includeFiles]
-    $cfgData = db[:cfgData]
-    $asmLabel = db[:asmLabel]
-    $endianLittle = db[:endianLittle]
-    $cfg3Data = db[:cfg3Data] || db[:cfg2Data]
+    db.roots.each do |var|
+      eval("$#{var} = db[:#{var}]")
+    end
   end
 
@@ -557,13 +553,17 @@
 $romImageFileName = nil
 $romSymbolFileName = nil
-$dependencyFileName = nil
 $idInputFileName = nil
 $idOutputFileName = nil
+$dependencyFileName = nil
+$omitOutputDb = false
+$supportDomain = false
+$supportClass = false
 
 #
 #  オプションの処理
 #
-OptionParser.new(banner="Usage: cfg.rb [options] CONFIG-FILE", 40) do |opt|
+OptionParser.new("Usage: cfg.rb [options] CONFIG-FILE", 40) do |opt|
   opt.version = VERSION
+  opt.release = nil
   opt.on("-k KERNEL", "--kernel KERNEL", "kernel profile name") do |val|
     $kernel = val
@@ -605,9 +605,17 @@
     $omitOutputDb = true
   end
+  opt.on("--enable-domain", "enable DOMAIN support") do
+	$supportDomain = true
+  end
+  opt.on("--enable-class", "enable CLASS support") do
+	$supportClass = true
+  end
   opt.on("-v", "--version", "show version number") do
-    abort(opt.ver)
+    puts(opt.ver)
+    exit(0)
   end
   opt.on("-h", "--help", "show help (this)") do
-    abort(opt.help)
+    puts(opt.help)
+    exit(0)
   end
   opt.parse!(ARGV)
@@ -642,4 +650,7 @@
 	$supportDomain = true
 when /^fmp/
+	$supportClass = true
+when /^hrmp/
+	$supportDomain = true
 	$supportClass = true
 end
Index: EcnlProtoTool/trunk/asp3_dcre/cfg/pass1.rb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/cfg/pass1.rb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/cfg/pass1.rb	(revision 429)
@@ -4,5 +4,5 @@
 #
 #  Copyright (C) 2015 by FUJI SOFT INCORPORATED, JAPAN
-#  Copyright (C) 2015-2017 by Embedded and Real-Time Systems Laboratory
+#  Copyright (C) 2015-2018 by Embedded and Real-Time Systems Laboratory
 #              Graduate School of Information Science, Nagoya Univ., JAPAN
 #
@@ -36,5 +36,5 @@
 #  の責任を負わない．
 #
-#  $Id$
+#  $Id: pass1.rb 165 2019-01-11 01:29:47Z ertl-hiro $
 #
 
@@ -61,5 +61,9 @@
   "LONG_MAX"  => { EXPR: "LONG_MAX",  SIGNED: true },
   "LONG_MIN"  => { EXPR: "LONG_MIN",  SIGNED: true },
-  "ULONG_MAX" => { EXPR: "ULONG_MAX" }
+  "ULONG_MAX" => { EXPR: "ULONG_MAX" },
+  "SIL_ENDIAN_BIG" \
+	=> { EXPR: "true", BOOL: true, CONDITION: "defined(SIL_ENDIAN_BIG)" },
+  "SIL_ENDIAN_LITTLE" \
+	=> { EXPR: "true", BOOL: true, CONDITION: "defined(SIL_ENDIAN_LITTLE)" }
 }
 
@@ -68,5 +72,5 @@
 #
 $apiDefinition = { "INCLUDE" =>
-  { :PARAM => [ { :NAME => :file, :STRING => true }]}}
+  { :PARAM => [ { :NAME => :file, :STRING_LITERAL => true }]}}
 
 #
@@ -121,8 +125,12 @@
             apiParam[:EXPTYPE] = "signed_t"
             apiParam[:SIGNED] = true
+          when "^"					# ポインタ整数定数式パラメータ
+            apiParam[:EXPTYPE] = "uintptr_t"
+            apiParam[:INTPTR] = true
           when "&"					# 一般整数定数式パラメータ
             # do nothing
           when "$"					# 文字列定数式パラメータ
             apiParam[:STRING] = true
+            apiParam[:EXPTYPE] = "char *"
           else
             error_exit("`#{param}' is invalid")
@@ -171,12 +179,16 @@
 						{ skip_blanks: true, skip_lines: /^#/ })
     symvalCsv.each do |record|
+      symbol = {}
+
       # 変数名
       if record[0].nil?
         error_exit("invalid variable name in " \
 						"`#{symvalTableFileName}:#{symvalCsv.to_io.lineno}'")
-      end
-
-      symbol = {}
-      variable = record[0]
+      elsif /^(.+)\[(.+)\]$/ =~ record[0]
+        variable = $1
+        symbol[:NUMSTRVAR] = $2
+      else
+        variable = record[0]
+      end
 
       # 式
@@ -192,4 +204,6 @@
         when /^[bB]/				# 真偽値
           symbol[:BOOL] = true
+        when /^[iI]/				# ポインタ整数値
+          symbol[:INTPTR] = true
         when /^[uU]/				# 符号無し整数値
           # 何も設定しない
@@ -367,5 +381,5 @@
     skipSpace(cfgFile, withinApi)
     if @line.nil?							# ファイル末であればエラー終了
-      error_exit("unexpexced end-of-file")
+      error_exit("#{cfgFile.getFileName}: unexpeced end-of-file")
     end
   end
@@ -472,5 +486,5 @@
     end
 
-    if apiParam.has_key?(:STRING)
+    if apiParam.has_key?(:STRING_LITERAL)
       return(param.unquote)
     else
@@ -604,8 +618,9 @@
         # プリプロセッサディレクティブを読む
         case @line
-        when /^#include\b(.*)$/
-          $includeFiles.push($1.strip)
-        when /^#(ifdef|ifndef|if|endif|else|elif)\b/
-          directive = { :DIRECTIVE => @line.strip }
+        when /^#(include|ifdef|ifndef|if|endif|else|elif)\b/
+          directive = {}
+          directive[:DIRECTIVE] = @line.strip
+          directive[:_FILE_] = cfgFile.getFileName
+          directive[:_LINE_] = cfgFile.getLineNo
           $cfgFileInfo.push(directive)
         else
@@ -619,5 +634,5 @@
         case apiName
         when "KERNEL_DOMAIN"
-          if $supportDomain.nil?
+          if !$supportDomain
             parse_warning(cfgFile, "`KERNEL_DOMAIN' is not supported")
           end
@@ -629,5 +644,5 @@
           @@nestDC.push("domain")
         when "DOMAIN"
-          if $supportDomain.nil?
+          if !$supportDomain
             parse_warning(cfgFile, "`DOMAIN' is not supported")
           end
@@ -655,5 +670,5 @@
           @@nestDC.push("domain")
         when "CLASS"
-          if $supportClass.nil?
+          if !$supportClass
             parse_warning(cfgFile, "`CLASS' is not supported")
           end
@@ -676,5 +691,9 @@
               includeFilePath = SearchFilePath(staticApi[:file])
               if includeFilePath.nil?
-                parse_error(cfgFile, "`#{staticApi[:file]}' not found")
+                error = {}
+                error[:DIRECTIVE] = "#error '#{staticApi[:file]}' not found."
+                error[:_FILE_] = cfgFile.getFileName
+                error[:_LINE_] = cfgFile.getLineNo
+                $cfgFileInfo.push(error)
               else
                 $dependencyFiles.push(includeFilePath)
@@ -694,4 +713,12 @@
               $cfgFileInfo.push(staticApi)
             end
+
+            # ";"を読む
+            skipToToken(cfgFile, false)		# 次の文字まで読み飛ばす
+            if (/^\;(.*)$/ =~ @line)
+              @line = $1
+            else
+              parse_error(cfgFile, "`;' expected after static API")
+            end
           else
             parse_error(cfgFile, "unknown static API: #{apiName}")
@@ -727,5 +754,5 @@
   #
   def self.OutLineNumber(cfgInfo)
-    @cfg1Out.add("#line #{cfgInfo[:_LINE_]} \"#{cfgInfo[:_FILE_].gsub('\\', '/')}\"")
+    @cfg1Out.add("#line #{cfgInfo[:_LINE_]} \"#{cfgInfo[:_FILE_]}\"")
   end
 
@@ -734,5 +761,5 @@
   #
   def self.OutClassLineNumber(cfgInfo)
-    @cfg1Out.add("#line #{cfgInfo[:CLASS_LINE_]} \"#{cfgInfo[:CLASS_FILE_].gsub('\\', '/')}\"")
+    @cfg1Out.add("#line #{cfgInfo[:CLASS_LINE_]} \"#{cfgInfo[:CLASS_FILE_]}\"")
   end
 
@@ -763,7 +790,10 @@
 EOS
 
-    # インクルードヘッダファイル
-    $includeFiles.each do |file|
-      @cfg1Out.add("#include #{file}")
+    # インクルードディレクティブ（#include）の生成
+    $cfgFileInfo.each do |cfgInfo|
+      if cfgInfo.has_key?(:DIRECTIVE)
+        OutLineNumber(cfgInfo)
+        @cfg1Out.add(cfgInfo[:DIRECTIVE])
+      end
     end
 
@@ -780,18 +810,17 @@
 #include "#{CFG1_OUT_TARGET_H}"
 
-#if defined(SIL_ENDIAN_BIG) && defined(SIL_ENDIAN_LITTLE)
-#error Both SIL_ENDIAN_BIG and SIL_ENDIAN_LITTLE are defined.
-#endif
-#if !defined(SIL_ENDIAN_BIG) && !defined(SIL_ENDIAN_LITTLE)
-#error Neither SIL_ENDIAN_BIG nor SIL_ENDIAN_LITTLE is defined.
-#endif
-
 const uint32_t #{CFG1_MAGIC_NUM} = 0x12345678;
 const uint32_t #{CFG1_SIZEOF_SIGNED} = sizeof(signed_t);
+const uint32_t #{CFG1_SIZEOF_INTPTR} = sizeof(intptr_t);
+const uint32_t #{CFG1_SIZEOF_CHARPTR} = sizeof(char *);
 EOS
 
     # 値取得シンボルの処理
     $symbolValueTable.each do |symbolName, symbolData|
-      if symbolData.has_key?(:BOOL) || symbolData.has_key?(:SIGNED)
+      if symbolData.has_key?(:BOOL)
+        type = "signed_t"
+      elsif symbolData.has_key?(:INTPTR)
+        type = "uintptr_t"
+      elsif symbolData.has_key?(:SIGNED)
         type = "signed_t"
       else
@@ -825,5 +854,9 @@
     $cfgFileInfo.each do |cfgInfo|
       if cfgInfo.has_key?(:DIRECTIVE)
-        @cfg1Out.add2(cfgInfo[:DIRECTIVE])
+        # 条件ディレクティブを出力
+        if cfgInfo[:DIRECTIVE] =~ /^#(ifdef|ifndef|if|endif|else|elif)\b/
+          OutLineNumber(cfgInfo)
+          @cfg1Out.add2(cfgInfo[:DIRECTIVE])
+        end
       else
         apiDef = $apiDefinition[cfgInfo[:APINAME]]
@@ -882,5 +915,4 @@
   $cfgFileInfo = []
   $dependencyFiles = $configFileNames.dup
-  $includeFiles = []
   $domainId = { "TDOM_KERNEL" => -1, "TDOM_NONE" => -2 }
   $configFileNames.each do |configFileName|
@@ -939,5 +971,5 @@
   #  パス2に引き渡す情報をファイルに生成
   #
-  if $omitOutputDb.nil?
+  if !$omitOutputDb
     db = PStore.new(CFG1_OUT_DB)
     db.transaction do
@@ -945,5 +977,4 @@
       db[:symbolValueTable] = $symbolValueTable
       db[:cfgFileInfo] = $cfgFileInfo
-      db[:includeFiles] = $includeFiles
       db[:domainId] = $domainId
     end
Index: EcnlProtoTool/trunk/asp3_dcre/cfg/pass2.rb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/cfg/pass2.rb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/cfg/pass2.rb	(revision 429)
@@ -4,5 +4,5 @@
 #
 #  Copyright (C) 2015 by FUJI SOFT INCORPORATED, JAPAN
-#  Copyright (C) 2015-2017 by Embedded and Real-Time Systems Laboratory
+#  Copyright (C) 2015-2018 by Embedded and Real-Time Systems Laboratory
 #              Graduate School of Information Science, Nagoya Univ., JAPAN
 #
@@ -36,5 +36,5 @@
 #  の責任を負わない．
 #
-#  $Id$
+#  $Id: pass2.rb 175 2019-06-19 01:51:58Z ertl-hiro $
 #
 
@@ -59,4 +59,17 @@
 
   #
+  #  Sレコードファイルからシンボルの文字列を取り出す
+  #
+  def self.GetSymbolString(symbol)
+    if @symbolAddress.has_key?(symbol) \
+			&& !(address = @cfg1SRec.get_value(@symbolAddress[symbol], \
+												$sizeOfCharPtr, false)).nil?
+      return(@cfg1SRec.get_string(address))
+    else
+      return(nil)
+    end
+  end
+
+  #
   #  パス1の生成物の読み込み（メインの処理）
   #
@@ -72,5 +85,5 @@
     end
 
-    # マジックナンバーの取得
+    # マジックナンバーの取得とエンディアンの設定
     if @symbolAddress.has_key?(CFG1_MAGIC_NUM)
       $asmLabel = ""
@@ -95,4 +108,6 @@
     # 固定出力した変数の取得
     $sizeOfSigned = GetSymbolValue($asmLabel + CFG1_SIZEOF_SIGNED, 4, false)
+    $sizeOfIntptr = GetSymbolValue($asmLabel + CFG1_SIZEOF_INTPTR, 4, false)
+    $sizeOfCharPtr = GetSymbolValue($asmLabel + CFG1_SIZEOF_CHARPTR, 4, false)
 
     # 値取得シンボルの取得
@@ -106,9 +121,33 @@
         end
       else
-        value = GetSymbolValue(symbol, $sizeOfSigned, \
+        if symbolData.has_key?(:INTPTR)
+          value = GetSymbolValue(symbol, $sizeOfIntptr, \
 										symbolData.has_key?(:SIGNED))
+        else
+          value = GetSymbolValue(symbol, $sizeOfSigned, \
+										symbolData.has_key?(:SIGNED))
+        end
         if !value.nil?
           symbolData[:VALUE] = value
         end
+      end
+    end
+
+    # SILによるエンディアン定義のチェック
+    if $symbolValueTable["SIL_ENDIAN_BIG"].has_key?(:VALUE)
+      if $symbolValueTable["SIL_ENDIAN_LITTLE"].has_key?(:VALUE)
+        error_exit("Both SIL_ENDIAN_BIG and SIL_ENDIAN_LITTLE are defined.")
+      else
+        if $endianLittle
+          error_exit("Definition of SIL_ENDIAN_BIG seems to be wrong.")
+        end
+      end
+    else
+      if $symbolValueTable["SIL_ENDIAN_LITTLE"].has_key?(:VALUE)
+        if !$endianLittle
+          error_exit("Definition of SIL_ENDIAN_LITTLE seems to be wrong.")
+        end
+      else
+        # 両方が未定義の場合のエラーチェックは，sil.hで実施する
       end
     end
@@ -133,10 +172,13 @@
 
     #
-    #  ドメイン生成データをコンフィギュレーションデータ（$cfgData）に格納
-    #
-    $cfgData[:CRE_DOM] = {}
-    $domainId.each do |domainName, domainVal|
-      domid = NumStr.new(domainVal, domainName)
-      $cfgData[:CRE_DOM][domainVal] = { :domid => domid }
+    #  ドメインデータ（$domData）を生成
+    #
+    if $supportDomain
+      $domData = {}
+      $domainId.each do |domainName, domainVal|
+        domid = NumStr.new(domainVal, domainName)
+        $domData[domainVal] = { :domid => domid }
+      end
+      $globalVars.push("domData")
     end
 
@@ -146,4 +188,6 @@
   #
   #  パラメータの値を取り出す
+  #
+  #  生成スクリプト内で追加された静的APIの場合には，apiIndexがnilになる．
   #
   def self.GetParamValue(paramName, param, apiIndex, index, apiParam, cfgInfo)
@@ -160,6 +204,22 @@
         value = nil
       end
+    elsif apiParam.has_key?(:STRING)			# 文字列パラメータ
+      if !apiIndex.nil?
+        symbol = "#{$cfg1_prefix}valueof_#{paramName}_#{apiIndex}#{index}"
+        return(GetSymbolString(symbol))
+      else
+        return(param)
+      end
     elsif apiParam.has_key?(:EXPTYPE)			# 整数定数式パラメータ
-      if apiIndex.nil?
+      if !apiIndex.nil?
+        symbol = "#{$cfg1_prefix}valueof_#{paramName}_#{apiIndex}#{index}"
+        if apiParam.has_key?(:INTPTR)
+          value = GetSymbolValue(symbol, $sizeOfIntptr, \
+										apiParam.has_key?(:SIGNED))
+        else
+          value = GetSymbolValue(symbol, $sizeOfSigned, \
+										apiParam.has_key?(:SIGNED))
+        end
+      else
         if param.is_a?(NumStr)
           return(param)
@@ -167,10 +227,6 @@
           return(NumStr.new(param))
         end
-      else
-        symbol = "#{$cfg1_prefix}valueof_#{paramName}_#{apiIndex}#{index}"
-        value = GetSymbolValue(symbol, $sizeOfSigned, \
-									apiParam.has_key?(:SIGNED))
-      end
-    else										# 一般定数式／文字列パラメータ
+      end
+    else										# 一般定数式パラメータ
       return(param)
     end
@@ -201,5 +257,4 @@
 
     # ID番号割り当ての前処理
-    objidParamNameList = []
     $cfgFileInfo.each do |cfgInfo|
       # プリプロセッサディレクティブは読み飛ばす
@@ -228,5 +283,4 @@
             @objidValues[objidParamName][objName] = nil
           end
-          objidParamNameList.push(objidParamName)
         end
       end
@@ -234,7 +288,5 @@
 
     # ID番号の割当て処理
-    objidParamNameList.each do |objidParamName|
-      objidList = @objidValues[objidParamName]
-
+    @objidValues.each do |objidParamName, objidList|
       # 未使用のID番号のリスト（使用したものから消していく）
       unusedObjidList = (1.upto(objidList.keys.size)).to_a
@@ -311,10 +363,10 @@
       # クラスIDを追加
       if cfgInfo.has_key?(:CLASS)
-        if apiIndex.nil?
-          params[:class] = cfgInfo[:CLASS]
-        else
+        if !apiIndex.nil?
           symbol = "#{$cfg1_prefix}valueof_CLASS_#{apiIndex}"
           value = GetSymbolValue(symbol, $sizeOfSigned, true)
           params[:class] = NumStr.new(value, cfgInfo[:CLASS])
+        else
+          params[:class] = cfgInfo[:CLASS]
         end
       end
@@ -343,4 +395,11 @@
 
   #
+  #  ID番号の割当て結果の上書き
+  #
+  def self.SetObjidList(objidParamName, objidList)
+    @objidValues[objidParamName] = objidList
+  end
+
+  #
   #  ID番号出力ファイルの生成
   #
@@ -364,11 +423,19 @@
   db = PStore.new(CFG1_OUT_DB)
   db.transaction(true) do
-    $apiDefinition = db[:apiDefinition]
-    $symbolValueTable = db[:symbolValueTable]
-    $cfgFileInfo = db[:cfgFileInfo]
-    $includeFiles = db[:includeFiles]
-    $domainId = db[:domainId]
-  end
-  $cfg2Data = {}
+    db.roots.each do |var|
+      eval("$#{var} = db[:#{var}]")
+    end
+  end
+
+  #
+  #  パス3以降に引き渡す情報の定義
+  #
+  $globalVars = [ "globalVars",
+                  "apiDefinition",
+                  "symbolValueTable",
+                  "cfgFileInfo",
+                  "cfgData",
+                  "asmLabel",
+                  "endianLittle" ]
 
   #
@@ -404,15 +471,10 @@
   #  パス3に引き渡す情報をファイルに生成
   #
-  if $omitOutputDb.nil?
+  if !$omitOutputDb
     db = PStore.new(CFG2_OUT_DB)
     db.transaction do
-      db[:apiDefinition] = $apiDefinition
-      db[:symbolValueTable] = $symbolValueTable
-      db[:cfgFileInfo] = $cfgFileInfo
-      db[:includeFiles] = $includeFiles
-      db[:cfgData] = $cfgData
-      db[:asmLabel] = $asmLabel
-      db[:endianLittle] = $endianLittle
-      db[:cfg2Data] = $cfg2Data
+      $globalVars.each do |var|
+        eval("db[:#{var}] = $#{var}")
+      end
     end
   end
Index: EcnlProtoTool/trunk/asp3_dcre/configure.rb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/configure.rb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/configure.rb	(revision 429)
@@ -7,5 +7,5 @@
 #  Copyright (C) 2001-2003 by Embedded and Real-Time Systems Laboratory
 #                              Toyohashi Univ. of Technology, JAPAN
-#  Copyright (C) 2006-2016 by Embedded and Real-Time Systems Laboratory
+#  Copyright (C) 2006-2019 by Embedded and Real-Time Systems Laboratory
 #              Graduate School of Information Science, Nagoya Univ., JAPAN
 # 
@@ -42,4 +42,5 @@
 # 
 
+Encoding.default_external = 'utf-8'
 require "optparse"
 require "fileutils"
@@ -56,8 +57,9 @@
 #						ル名）名
 #  -C <cdlflle>			コンポーネント記述ファイル（.cdlファイル）名
-#  -U <applobjs>		他のアプリケーションプログラムファイル
+#  -U <applobjs>		アプリケーションの追加のオブジェクトファイル
 #						（.oファイル名で指定．複数指定可）
-#  -S <syssvcobjs>		システムサービスのプログラムファイル
+#  -S <syssvcobjs>		システムサービスのオブジェクトファイル
 #						（.oファイル名で指定．複数指定可）
+#  -B <bannerobj>		バナー表示のオブジェクトファイル（.oファイル名で指定）
 #  -L <kernel_lib>		カーネルライブラリ（libkernel.a）のディレクトリ名
 #						（省略した場合，カーネルライブラリもmakeする）
@@ -67,6 +69,9 @@
 #  -m <tempmakefile>	Makefileのテンプレートのファイル名の指定（デフォル
 #						トはsampleディレクトリのMakefile）
-#  -d <depdir>			依存関係ファイルのディレクトリ名（デフォルトはdeps）
+#  -d <objdir>			中間オブジェクトファイルと依存関係ファイルを置く
+#						ディレクトリ名（デフォルトはobjs）
 #  -w					TECSを使用しない
+#  -W <tecsdir>			TECS関係ファイルのディレクトリ名（デフォルトはソー
+#						スファイルのディレクトリの下のtecsgen）
 #  -r					トレースログ記録のサンプルコードを使用するかどうか
 #						の指定
@@ -77,5 +82,6 @@
 #  -o <options>			コンパイルオプション（COPTSに追加）
 #  -O <options>			シンボル定義オプション（CDEFSに追加）
-#  -k <options>			リンカオプション（LDFLAGS等に追加）
+#  -k <options>			リンカオプション（LDFLAGSに追加）
+#  -b <options>			リンカオプション（LIBSに追加）
 #  -e <tinetdir>		TINET のソースの置かれているディレクトリ
 #  -i <net_if>			ネットワークインタフェース（TINETが有効の場合は必須）
@@ -111,5 +117,5 @@
 #
 #  % ../configure.rb -T gr_sakura_gcc -A sample1n \
-#					-e tinet -i ether -v if_rx62n -n inet4 -s tcp -U sample1.o
+#					-e tinet -i ether -v if_mbed -n inet4 -s tcp -U sample1.o
 #	TINETを有効にする．
 
@@ -119,17 +125,28 @@
 $target = nil
 $appldirs = []
+$applname = nil
+$option_t = false
+$cfgfile = nil
+$cdlfile = nil
 $applobjs = []
 $syssvcobjs = []
+$bannerobj = nil
 $kernel_lib = ""
 $kernel_funcobjs = ""
+$srcdir = nil
 $srclang = "c"
-$depdir = "deps"
+$tempmakefile = nil
+$objdir = "objs"
 $omit_tecs = ""
+$tecsdir = nil
 $enable_trace = ""
 $devtooldir = ""
 $ruby = "ruby"
+$cfg = nil
+$tecsgen = nil
 $copts = []
 $cdefs = []
 $ldflags = []
+$libs = []
 
 #
@@ -141,5 +158,5 @@
   end
   opt.on("-a appldirs",		"application directories") do |val|
-    $appldirs += val.split("\s+")
+    $appldirs += val.split(/\s+/)
   end
   opt.on("-A applname",		"application program name") do |val|
@@ -156,8 +173,11 @@
   end
   opt.on("-U applobjs",		"additional application object files") do |val|
-    $applobjs += val.split("\s+")
+    $applobjs += val.split(/\s+/)
   end
   opt.on("-S syssvcobjs",	"system service object files") do |val|
-    $syssvcobjs += val.split("\s+")
+    $syssvcobjs += val.split(/\s+/)
+  end
+  opt.on("-B bannerobj",	"banner display object file") do |val|
+    $bannerobj = val
   end
   opt.on("-L kernel_lib",	"directory of built kernel library") do |val|
@@ -165,5 +185,5 @@
   end
   opt.on("-f", "each function is complied separately in kernel") do |val|
-    $kernel_funcobjs = true
+    $kernel_funcobjs = "true"
   end
   opt.on("-D srcdir",		"path of source code directory") do |val|
@@ -176,12 +196,15 @@
     $tempmakefile = val
   end
-  opt.on("-d depdir",		"dependency relation file directory") do |val|
-    $depdir = val
+  opt.on("-d objdir",		"relocatable object file directory") do |val|
+    $objdir = val
   end
   opt.on("-w",				"TECS is not used at all") do |val|
-    $omit_tecs = true
+    $omit_tecs = "true"
+  end
+  opt.on("-W tecsdir",		"path of TECS file directory") do |val|
+    $tecsdir = val
   end
   opt.on("-r",				"use the sample code for trace log") do |val|
-    $enable_trace = true
+    $enable_trace = "true"
   end
   opt.on("-V devtooldir",	"development tools directory") do |val|
@@ -198,11 +221,14 @@
   end
   opt.on("-o options",		"compiler options") do |val|
-    $copts += val.split("\s+")
+    $copts += val.split(/\s+/)
   end
   opt.on("-O options",		"symbol definition options") do |val|
-    $cdefs += val.split("\s+")
+    $cdefs += val.split(/\s+/)
   end
   opt.on("-k options",		"linker options") do |val|
-    $ldflags += val.split("\s+")
+    $ldflags += val.split(/\s+/)
+  end
+  opt.on("-b options",		"linker options for linking libraries") do |val|
+    $libs += val.split(/\s+/)
   end
   opt.on("-e options",		"path of TINET directory") do |val|
@@ -236,5 +262,5 @@
 
 #
-#  変数のデフォルト値
+#  変数のデフォルト値（文字列変数のデフォルト値は初期化で与える）
 #
 if $appldirs.empty?
@@ -242,9 +268,8 @@
 end
 $applname ||= "sample1"
-if $option_t.nil?
-  $applobjs.unshift($applname + ".o")
-end
 $cfgfile ||= $applname + ".cfg"
 $cdlfile ||= $applname + ".cdl"
+$applobjs.unshift($applname + ".o") if !$option_t
+$bannerobj ||= ($omit_tecs == "") ? "tBannerMain.o" : "banner.o"
 if $srcdir.nil?
   # ソースディレクトリ名を取り出す
@@ -261,6 +286,7 @@
 end
 $tempmakefile ||= $srcdir + "/sample/Makefile"
+$tecsdir ||= "\$(SRCDIR)/tecsgen"
 $cfg ||= $ruby + " \$(SRCDIR)/cfg/cfg.rb"
-$tecsgen ||= $ruby + " \$(SRCDIR)/tecsgen/tecsgen.rb"
+$tecsgen ||= $ruby + " \$(TECSDIR)/tecsgen.rb"
 
 #
@@ -294,4 +320,5 @@
 $vartable["APPLOBJS"] = $applobjs.join(" ")
 $vartable["SYSSVCOBJS"] = $syssvcobjs.join(" ")
+$vartable["BANNEROBJ"] = $bannerobj
 $vartable["KERNEL_LIB"] = $kernel_lib
 $vartable["KERNEL_FUNCOBJS"] = $kernel_funcobjs
@@ -299,6 +326,7 @@
 $vartable["SRCABSDIR"] = $srcabsdir
 $vartable["SRCLANG"] = $srclang
-$vartable["DEPDIR"] = $depdir
+$vartable["OBJDIR"] = $objdir
 $vartable["OMIT_TECS"] = $omit_tecs
+$vartable["TECSDIR"] = $tecsdir
 $vartable["ENABLE_TRACE"] = $enable_trace
 $vartable["DEVTOOLDIR"] = $devtooldir
@@ -309,4 +337,5 @@
 $vartable["CDEFS"] = $cdefs.join(" ")
 $vartable["LDFLAGS"] = $ldflags.join(" ")
+$vartable["LIBS"] = $libs.join(" ")
 $vartable["OBJEXT"] = GetObjectExtension()
 $vartable["TINETDIR"] = $tinetdir
@@ -362,5 +391,5 @@
 #  依存関係ファイルのディレクトリの作成
 #
-if !File.directory?($depdir)
-  Dir.mkdir($depdir)
-end
+if !File.directory?($objdir)
+  Dir.mkdir($objdir)
+end
Index: EcnlProtoTool/trunk/asp3_dcre/include/kernel.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/include/kernel.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/include/kernel.h	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2004-2015 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2004-2019 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -80,4 +80,16 @@
 #endif /* TOPPERS_TARGET_SUPPORT_ENA_INT */
 
+#ifdef TOPPERS_TARGET_SUPPORT_CLR_INT
+#define TOPPERS_SUPPORT_CLR_INT			/* clr_intがサポートされている */
+#endif /* TOPPERS_TARGET_SUPPORT_CLR_INT */
+
+#ifdef TOPPERS_TARGET_SUPPORT_RAS_INT
+#define TOPPERS_SUPPORT_RAS_INT			/* ras_intがサポートされている */
+#endif /* TOPPERS_TARGET_SUPPORT_RAS_INT */
+
+#ifdef TOPPERS_TARGET_SUPPORT_PRB_INT
+#define TOPPERS_SUPPORT_PRB_INT			/* prb_intがサポートされている */
+#endif /* TOPPERS_TARGET_SUPPORT_PRB_INT */
+
 #define TOPPERS_SUPPORT_DYNAMIC_CRE		/* 動的生成機能拡張 */
 
@@ -195,5 +207,5 @@
 	PRI			itskpri;	/* タスクの起動時優先度 */
 	size_t		stksz;		/* タスクのスタック領域のサイズ */
-	STK_T 		*stk;		/* タスクのスタック領域の先頭番地 */
+	STK_T		*stk;		/* タスクのスタック領域の先頭番地 */
 } T_CTSK;
 
@@ -235,5 +247,5 @@
 	ATR		dtqatr;		/* データキュー属性 */
 	uint_t	dtqcnt;		/* データキュー管理領域に格納できるデータ数 */
-	void 	*dtqmb;		/* データキュー管理領域の先頭番地 */
+	void	*dtqmb;		/* データキュー管理領域の先頭番地 */
 } T_CDTQ;
 
@@ -249,5 +261,5 @@
 	PRI		maxdpri;	/* 優先度データキューに送信できるデータ優先度の最
 						   大値 */
-	void 	*pdqmb;		/* 優先度データキュー管理領域の先頭番地 */
+	void	*pdqmb;		/* 優先度データキュー管理領域の先頭番地 */
 } T_CPDQ;
 
@@ -275,6 +287,6 @@
 	uint_t	blkcnt;		/* 獲得できる固定長メモリブロックの数 */
 	uint_t	blksz;		/* 固定長メモリブロックのサイズ */
-	MPF_T 	*mpf;		/* 固定長メモリプール領域の先頭番地 */
-	void 	*mpfmb;		/* 固定長メモリプール管理領域の先頭番地 */
+	MPF_T	*mpf;		/* 固定長メモリプール領域の先頭番地 */
+	void	*mpfmb;		/* 固定長メモリプール管理領域の先頭番地 */
 } T_CMPF;
 
@@ -471,4 +483,7 @@
 extern ER		dis_int(INTNO intno) throw();
 extern ER		ena_int(INTNO intno) throw();
+extern ER		clr_int(INTNO intno) throw();
+extern ER		ras_int(INTNO intno) throw();
+extern ER_BOOL	prb_int(INTNO intno) throw();
 extern ER		chg_ipm(PRI intpri) throw();
 extern ER		get_ipm(PRI *p_intpri) throw();
@@ -508,4 +523,7 @@
 #define idis_int(intno)						dis_int(intno)
 #define iena_int(intno)						ena_int(intno)
+#define iclr_int(intno)						clr_int(intno)
+#define iras_int(intno)						ras_int(intno)
+#define iprb_int(intno)						prb_int(intno)
 #define ixsns_dpn(p_excinf)					xsns_dpn(p_excinf)
 
@@ -613,6 +631,6 @@
 #define TKERNEL_MAKER	UINT_C(0x0118)	/* カーネルのメーカーコード */
 #define TKERNEL_PRID	UINT_C(0x0007)	/* カーネルの識別番号 */
-#define TKERNEL_SPVER	UINT_C(0xf631)	/* カーネル仕様のバージョン番号 */
-#define TKERNEL_PRVER	UINT_C(0x3010)	/* カーネルのバージョン番号 */
+#define TKERNEL_SPVER	UINT_C(0xf634)	/* カーネル仕様のバージョン番号 */
+#define TKERNEL_PRVER	UINT_C(0x3050)	/* カーネルのバージョン番号 */
 
 /*
@@ -632,5 +650,5 @@
  *  システム時刻の調整できる範囲（単位：μ秒）
  */
-#define TMIN_ADJTIM		-1000000		/* システム時刻の最小調整時間 */
+#define TMIN_ADJTIM		(-1000000)		/* システム時刻の最小調整時間 */
 #define TMAX_ADJTIM		1000000			/* システム時刻の最大調整時間 */
 
@@ -654,14 +672,17 @@
 #define ROUND_MPF_T(blksz)	TOPPERS_ROUND_SZ(blksz, sizeof(MPF_T))
 
+#define COUNT_MB_T(sz)		TOPPERS_COUNT_SZ(sz, sizeof(MB_T))
+#define ROUND_MB_T(sz)		TOPPERS_ROUND_SZ(sz, sizeof(MB_T))
+
 #define TSZ_DTQMB(dtqcnt)	(sizeof(intptr_t) * (dtqcnt))
-#define TCNT_DTQMB(dtqcnt)	TOPPERS_COUNT_SZ(TSZ_DTQMB(dtqcnt), sizeof(MB_T))
+#define TCNT_DTQMB(dtqcnt)	COUNT_MB_T(TSZ_DTQMB(dtqcnt))
 
 #ifndef TSZ_PDQMB
 #define TSZ_PDQMB(pdqcnt)	(sizeof(intptr_t) * 3 * (pdqcnt))
 #endif /* TSZ_PDQMB */
-#define TCNT_PDQMB(pdqcnt)	TOPPERS_COUNT_SZ(TSZ_PDQMB(pdqcnt), sizeof(MB_T))
+#define TCNT_PDQMB(pdqcnt)	COUNT_MB_T(TSZ_PDQMB(pdqcnt))
 
 #define TSZ_MPFMB(blkcnt)	(sizeof(uint_t) * (blkcnt))
-#define TCNT_MPFMB(blkcnt)	TOPPERS_COUNT_SZ(TSZ_MPFMB(blkcnt), sizeof(MB_T))
+#define TCNT_MPFMB(blkcnt)	COUNT_MB_T(TSZ_MPFMB(blkcnt))
 
 /*
